<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { ref, onMounted, onUnmounted, watch } from 'vue';
import { Dialog, DialogPanel, TransitionRoot, TransitionChild } from '@headlessui/vue';

const props = defineProps<{
    src: string,
    iframeURL?: string,
    topbarClass?: string, 
    imgSize?: string
}>();

const emits = defineEmits<{
    (e: 'loaded'): void
}>();

const showFullscreen = ref(false);
const showTransitionFullscreen = ref(false);
const isIntersecting = ref(false);
const isLoaded = ref(false);
const containerRef = ref<HTMLImageElement | null>(null);
const loadedImageSrc = ref("");

let observer: IntersectionObserver | null = null;

const preloadImage = (src: string): Promise<string> => {
  return new Promise((resolve, reject) => {
    const img = new Image();
    img.src = src;
    img.onload = () => resolve(src);
    img.onerror = reject;
  })
};

const loadImage = async (): Promise<void> => {
  try {
    const src = await preloadImage(props.src);
    loadedImageSrc.value = src;
    isLoaded.value = true;
    emits('loaded');
  } catch (error) {
    console.error('Failed to load image:', error);
  }
};

onMounted(() => {
  observer = new IntersectionObserver(([entry]) => {
    isIntersecting.value = entry.isIntersecting;
  });
  if (containerRef.value) observer.observe(containerRef.value);
});

onUnmounted(() => {
  if (observer) {
    observer.disconnect();
  }
});

watch(isIntersecting, (newValue: boolean) => {
  if (newValue && !isLoaded.value) {
    loadImage();
  }
});

const handleOpenLightBox = () => {
    showFullscreen.value = true;
    showTransitionFullscreen.value = true;

};
const handleCloseLightBox = () => {
    showTransitionFullscreen.value = false;
    setTimeout(() => {
        showFullscreen.value = false;
    }, 300);
};

</script>
<template>
    <div class="w-full" ref="containerRef">
        <img v-show="loadedImageSrc" :src="loadedImageSrc" class="object-contain m-auto w-full" :class="topbarClass" :style="{maxHeight: imgSize}" @click="handleOpenLightBox"
        />
        <div class="h-20 w-full bg-white text-center text-gray-500 flex flex-col justify-center" v-show="!loadedImageSrc">
            <div class="flex flex-row gap-2 w-full px-2">
                <svg class="animate-spin h-4 w-4 mt-1 text-black" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24">
                    <circle class="opacity-25" cx="12" cy="12" r="10" stroke="currentColor" stroke-width="4"></circle>
                    <path class="opacity-75" fill="currentColor" d="M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z"></path>
                </svg>
                <span>{{ $t("general.variables.loadImage.label") }}</span>
            </div>
        </div>
        <TransitionRoot :show="showTransitionFullscreen" as="template">
            <Dialog :open="showFullscreen" class="relative z-[9998]" as="div">
                <TransitionChild as="template" enter="duration-300 ease-out" enter-from="opacity-0" enter-to="opacity-100"
                    leave="duration-200 ease-in" leave-from="opacity-100" leave-to="opacity-0">
                    <div aria-hidden="true" class="fixed inset-0 bg-black/70"></div>
                </TransitionChild>
                <div class="fixed inset-0 flex justify-center">
                    <TransitionChild as="template" enter="duration-300 ease-out" enter-from="opacity-0 scale-50"
                        enter-to="opacity-100 scale-100" leave="duration-100 ease-in" leave-from="opacity-100 scale-100"
                        leave-to="opacity-0 scale-75">
                        <DialogPanel class="w-full max-w-5xl" as="div">
                            <div class="relative h-full select-none w-full">
                                <div class="absolute text-3xl top-20 right-5">
                                    <div class="size-10 hover:bg-gray-100 hover:text-gray-700 text-white rounded-md">
                                        <button
                                            class="w-full leading-10 align-middle text-center focus:outline-0 focus-within:outline-0"
                                            @click="handleCloseLightBox"><i
                                                class="ri-close-line leading-10 text-center"></i></button>
                                    </div>
                                </div>
                                <div class="flex flex-col justify-center p-20 mx-auto max-h-screen w-fit h-full" v-if="!iframeURL">
                                    <img class="pointer-events-none rounded-xl max-h-screen w-fit" :src="loadedImageSrc" />
                                </div>
                                <div class="flex flex-col justify-center p-20 h-full w-full mx-auto" v-else>
                                    <iframe class="rounded-xl" :src="iframeURL"></iframe>
                                </div>
                            </div>
                        </DialogPanel>
                    </TransitionChild>
                </div>
            </Dialog>
        </TransitionRoot>
    </div>
</template>